//////////////////////////////////////////////////////////////////////////////
//
// This source code is part of IATHook, 
//    a small demo of an Import Address Table Hooker
//
//                                   (c) Kay Bruns (http://kay-bruns.de), 2008
//////////////////////////////////////////////////////////////////////////////
#include <windows.h>
#include "DLLMain.h"
#include "IATHook.h"

HINSTANCE   l_hInst  = NULL;

HHOOK       g_hookShell = NULL;
HHOOK       g_hookMenu  = NULL;

// extern "C" prevents name mangling so that procedures can be referenced from outside the DLL
extern "C" static LRESULT CALLBACK ShellProc(int nCode, WPARAM wParam, LPARAM lParam)
{
  //Dummy! the Shell hooks are used for injection only
  return CallNextHookEx(g_hookShell, nCode, wParam, lParam);
}

extern "C" static LRESULT CALLBACK MenuProc(int nCode, WPARAM wParam, LPARAM lParam)
{
  //Dummy! the Shell hooks are used for injection only
  return CallNextHookEx(g_hookMenu, nCode, wParam, lParam);
}

__declspec(dllexport) BOOL InstallIATHook()
{
  if((g_hookShell!=NULL)&&(g_hookMenu!=NULL))
    return TRUE;
  if((g_hookShell!=NULL)||(g_hookMenu!=NULL))
    return FALSE;
  g_hookShell=SetWindowsHookEx(WH_CALLWNDPROC,(HOOKPROC)ShellProc,l_hInst,0);
  g_hookMenu =SetWindowsHookEx(WH_GETMESSAGE ,(HOOKPROC)MenuProc ,l_hInst,0);
  return (g_hookShell!= NULL) && (g_hookMenu != NULL);
}

__declspec(dllexport) BOOL UninstallIATHook()
{
  BOOL bRet=TRUE;
  if (g_hookShell)
    bRet&=(UnhookWindowsHookEx(g_hookShell)!=0);
  g_hookShell=NULL;
  if(g_hookMenu)
    bRet&=(UnhookWindowsHookEx(g_hookMenu)!=0);
  g_hookMenu=NULL;
  return bRet;
}

BOOL APIENTRY DllMain( HINSTANCE hInstDLL,DWORD dwReason,LPVOID lpReserved)
{
  switch(dwReason)
  {
  case DLL_PROCESS_ATTACH:
    if (l_hInst==hInstDLL)
      return TRUE;
    DisableThreadLibraryCalls(hInstDLL);
    l_hInst=hInstDLL;
    LoadHooks();
    return TRUE;
  case DLL_PROCESS_DETACH:
    UnloadHooks();
    l_hInst=NULL;
    return TRUE;
  }
  return TRUE;
}
